<?
###############################################################
#
#     FONCTION SQL DU MODULE CONTACTS 
#
###############################################################

######################################       INSERTION D ACTION

function SQL_INSERT_ACT($dbproc, $datas, $actid=0)
{
if (is_array($datas))
{
  /* init transaction */

  $res=SQL_BEGIN($dbproc);

  /* en mode update, on commence par effacer toute les infos
     avant de les inscrire  nouveau
  */

  if ($actid>0)
    {
      SQL_DELETE_ACTION($dbproc,$actid);
      $id=$actid;   // pour une mise  jour on rcupre l'id
    }
  else
    {
      $id=SQL_NEXT_ID($dbproc,"action_seq");
    }

  $status=0;

  /* on construit la requete */
  $query="insert into  action ( act_id,
                                act_hier_id,
                                act_date,";

  if ($datas[0]['act_duedate']<>'')
    $query.="act_duedate,";

  if ($datas[0]['act_effdate']<>'')
    $query.="act_effdate,";
  $query.="           act_curtype,
                            act_str,
                            act_shortdesc,
                            ts,
                            ent_id,
                            login_id )

        values (            $id, '"
    .$datas[0]['act_hier_id']."','"
    .$datas[0]['act_date']."','";

  if ($datas[0]['act_duedate']<>'')
    $query.=            $datas[0]['act_duedate']."','";

  if ($datas[0]['act_effdate']<>'')
    $query.=            $datas[0]['act_effdate']."','";

  $query.=            $datas[0]['act_curtype']."','"
    .substr($datas[0]['act_str'],0,255)."','"
    .$datas[0]['act_shortdesc']."',
                            now(),'"
    .$datas[0]['act_entid']."','"
    .$datas[0]['login_id']."')";

  $res=SQL_QUERY($query, $dbproc);
  if (!$res)
    $status+=1;

  /*on inclue les textes dpassant 255 caractres */

  $res=SQL_ACT_TEXT_INSERT($dbproc,$datas[0]['act_str'], $id);
  if ($res>-1)
    $status+=2;

  /* fin de la transaction */

  if ($status==0)
    { $res=SQL_COMMIT($dbproc); return $id;} // on ferme la transaction
  else
    {$res=SQL_ROLLBACK($dbproc); return -1;} // on ferme la transaction

}
 else
   return -1;
}

########################################  INSERTION DES TEXTE D UNE ACTION

/*     info: La transaction est dj initi dans la fonction appellante */

function SQL_ACT_TEXT_INSERT($dbproc,$str, $act_id)
{
if (strlen($str)>255 && (isset($act_id)))
{
  // on verifie si il y a deja des enregistrement concernant cette action
  $query="select count(act_id),ins_date from actiontext
            where act_id=$act_id
            GROUP BY ins_date";
  $sql_result=SQL_QUERY($query, $dbproc);

  if ($sql_result)
    {
      $dat=SQL_FETCH_RESULT($sql_result);
      $or_ins_date=$dat[0]['ins_date'];
    }
  else
    {
      $num=0;
      $or_ins_date='';
    }
  // on les efface aprs avoir garder leur ins_date
  if ($num>0)
    {
      $query="delete from \"ActionText\" where act_id=$act_id";
      SQL_QUERY($query, $dbproc);
    }
  // on dcoupe le str en bloc de 255 caractres
  // mais on commence  1 car les premiers 255 sont inscrit dans la table principale

  $seq = 1;
  $size = 255;
  $text_success = 1;
  while ($actxt_str = substr($str,$seq*$size,$size))
    {
      $act_txt_id=SQL_NEXT_ID($dbproc, "casetext_seq");
      if ($or_ins_date<>"")
    {
      $query = "INSERT INTO \"ActionText\"
                    (act_txt_id, act_id, act_seq, act_str, login_id, ins_date)
                    VALUES ('$act_txt_id','$act_id','$seq','$actxt_str',
                    '$user_id','$or_ins_date')";

    }
      else
    {
      $query = "INSERT INTO \"ActionText\"
              (act_txt_id, act_id, act_seq, act_str, login_id)
              VALUES ('$act_txt_id','$act_id','$seq','$actxt_str',
              '$user_id')";

    }

      $sql_result2=SQL_QUERY($query, $dbproc);
      if ($sql_result2 AND $text_success > 0)
        $text_success = 1;
      else
        $text_success = 0;
      $seq++;
    }
}
 else
   return -1;
}

################################################       SUPPRESSION D UNE ACTION

function SQL_DELETE_ACTION($dbproc, $actid)
{
  if ($actid>0)
    {
      /* init transaction */
      SQL_BEGIN($dbproc);
    
      /* on verifie si il existe des enfants */
      $query="select act_id from action where act_hier_id=$actid";
      $res=SQL_QUERY($query, $dbproc);
      if (SQL_NUM_ROWS($res)>0) $status++;
       
      /* on supprime l'action */
      $query="delete from  action  where act_id='$actid'";
      $res=SQL_QUERY($query, $dbproc);
      if (!isset($res)) $status+=2;

      /* on supprime les texte de l'actions*/
      $query="delete from actiontext where act_id='$actid'";
      $res=SQL_QUERY($query, $dbproc);
      if (!isset($res)) $status+=4;
      
      /* fin transaction */
      if ($status==0)
    SQL_COMMIT($dbproc);
      else
     SQL_ROLLBACK($dbproc);
    
      return $status;
      
    }
  else
    return -1;
}

################################################       LECTURE D UNE ACTION

function SQL_READ_ACTION($dbproc, $act_id)
{
if ($act_id>-1)
{
  /* on recupere les infos de la table action */
  $query="select *
           from  action 
           where act_id=$act_id";

  $res=SQL_QUERY($query, $dbproc);
  /* cette action existe-t-elle ?*/
  if (SQL_NUM_ROWS($res))
    {
      $action=SQL_FETCH_RESULT($res);

      /* on recupere le libelles du type */
      $tmp=SQL_READ_ACT_TYPE($dbproc, $action[0]['act_curtype']);
      if (is_array($tmp))
    $action[0]['act_curtype_lbl']=$tmp[0]['cat_lbl'];
      
      // on recupere le nom de la socit et l'id ainsi que
      
      $tmp=SQL_table_from_entid($dbproc,$action[0]['ent_id'] , "company", "ent_id");
      if (is_array($tmp))
    {
      $action[0]['act_cmp']=$tmp[0]['cmp_name'];
      $action[0]['act_cmp_id']=$tmp[0]['cmp_id'];
    }
      
      $tmp=SQL_table_from_entid($dbproc,$action[0]['ent_id'] , "person", "ent_id");
      if (is_array($tmp))
    {
      $action[0]['act_per']=$tmp[0]['per_lastname'];
      $action[0]['act_per_id']=$tmp[0]['per_id'];
    }
      
      // on cherche  reconstituer le champ content
      $query="select act_str, act_seq
            from actiontext
            where act_id=$act_id order by act_seq";
      $res=SQL_QUERY($query, $dbproc);
      
      if (SQL_NUM_ROWS($res)>0)
    {
      $txt='';
      $res2=SQL_FETCH_RESULT($res);
      for ($index=0;$index<count($res2);$index++)
        {
          $txt.=$res2[$index]['act_str'];
        }
      $action[0]['act_str'].=$txt;
    }
      return $action;
    }
  else
    return -1;
    }
  else
    return -1;


}
################################################       RECHERCHE D UNE ACTION
function SQL_SEARCH_ACTIONS($dbproc,$datas)
{
if (is_array($datas))
{
  $select="SELECT act_id, act_hier_id, ins_date, act_str, act_shortdesc from  action  act ";
  $where="WHERE true ";

  if ($datas[0]['act_bdate']<>'')
    $where.="AND act_date >'".$datas[0]['act_bdate']."' ";

  if ($datas[0]['act_edate']<>'')
    $where.="AND act_date <'".$datas[0]['act_edate']."' ";

  if (isset($datas[0]['act_topics']))
    {
      $search=SEARCH_STRING_TO_ARRAY($datas['act_topics']);

      $num=count($search);
      for ($index=0;$index<$num;$index++)
    {
      $where.="AND UPPER(act.act_str) like UPPER('%".$search[$index]."%') ";
      $where.="OR UPPER(act.act_shortdesc) like UPPER('%".$search[$index]."%') ";
      $where.="OR UPPER(act.act_shortdesc) like UPPER('%".$search[$index]."%') ";
    }
    }
  if (isset($datas[0]['act_entid']))
    $where.="AND act.ent_id ='".$datas[0]['act_entid']."' ";

  if (isset($datas[0]['act_hier_id']))
    $where.="AND act.act_hier_id ='".$datas[0]['act_hier_id']."' ";

  if (($datas[0]['type']=="typed"))
    $where.="AND act.act_curtype ='".$datas[0]['act_curtype']."' ";

  // if (isset($datas[0]['user_id']))
  //    $where.="AND act.user_id ='".$datas[0]['user_id']."' ";

  if ($datas[0]['roots']=="roots")
    $where.="AND act.act_hier_id=0 ";

  if (($datas[0]['login_id']>0))

    $where.="AND act.login_id=".$datas[0]['login_id']." ";

  if ($datas[0]['mode']=='todolist')

    $where.="AND act.act_duedate like '%".date("Y-m-d")."%'
                     AND act.act_effdate is null ";


  $where.="ORDER BY act.act_date DESC";

  $query=$select.$where;
  $res=SQL_QUERY($query, $dbproc);
  $res=SQL_FETCH_RESULT($res);

  // on rajoute les textes supplmentaires des actions
  // en utilisant la fonction read action

  for ($index=0;$index<count($res);$index++)
    {
      $action=SQL_READ_ACTION($dbproc, $res[$index]['act_id']);
      $actions[$index]=$action[0];
    }
}
 else
   {
     $action=SQL_READ_ACTION($dbproc, $data);
   }
 return $actions;
}


?>
