<?
###############################################################
#
#     FONCTION SQL DU MODULE DOC 
#
###############################################################

################################ SQL LINK DELETE
function SQL_DELETE_LINK($dbproc, $from_table, $from_id, $to_table, $to_id, $user_id)
{
  /* on verifie la cohrence des paramtres */
  if ($from_table.$from_id.$to_table.$to_id!="") 
    {
     	/* init transaction */
	SQL_BEGIN($dbproc);

	$query="DELETE FROM links 
                WHERE (from_table='$from_table'
                AND from_id='$from_id'
                AND to_table='$to_table'
                AND to_id='$to_id') 
		OR 
		(from_table='$to_table'
                AND from_id='$to_id'
                AND to_table='$from_table'
                AND to_id='$from_id')";
        
	$result=SQL_QUERY($query,$dbproc);


	/*fin transaction */
	if ($result)
	  {
	    SQL_COMMIT($dbproc);
	    return 0;
	  }
	else
	  {
	    SQL_ROLLBACK($dbproc);
	    return -1;
	  }
    }
}
################################# SQL LINK INSERT
function SQL_INSERT_LINK($dbproc, $from_table, $from_id, $to_table, $to_id, $user_id)
{
  /* on verifie la cohrence des paramtres */
  if ($from_table.$from_id.$to_table.$to_id!="") 
    {
      /* on verifie que le lien n'existe pas dj*/
      $query="SELECT link_id from links where 
              from_table='$from_table' 
              AND
              from_id='$from_id' 
              AND
              to_table='$to_table'
              AND
              to_id='$to_id'";
      
      $result=SQL_QUERY($query,$dbproc);
      if (SQL_NUM_ROWS($result)>0)
	{ 
	  SQL_FREE_RESULT($result);
	  return 1;
	}
      else
	
	/* sinon on insert */
	/* init transaction */
	SQL_BEGIN($dbproc);
	$query="INSERT INTO links(from_table, from_id, to_table, to_id, user_id) 
                VALUES ('$from_table','$from_id','$to_table','$to_id', '$user_id')";
        
	$result=SQL_QUERY($query,$dbproc);
	/*fin transaction */
	if ($result)
	  {
	    SQL_COMMIT($dbproc);
	    return 0;
	  }
	else
	  {
	    SQL_ROLLBACK($dbproc);
	    return -1;
	  }
    }
}

################################################## SUPPRESSION DE DOC
function SQL_DOC_DELETE ($dbproc, $doc_id)
{
  if (isset($doc_id))
    {
      
      /* init transaction */
      SQL_BEGIN($dbproc);
      $status=0; 

      /* suppression des textes de la doc */
      $query="DELETE FROM doctext WHERE doc_id=$doc_id";
      $res=SQL_QUERY($query, $dbproc);
      if (!isset($res)) $status+=1;
      
      /* suppression des liens de cette doc */
      $query="DELETE FROM links WHERE (to_id=$doc_id OR from_id=$doc_id)";
      $res=SQL_QUERY($query, $dbproc);
      if (!isset($res)) $status+=2;
      
      /* suppression des liens doc -> produits */
      $query="DELETE FROM doc_prod WHERE doc_id=$doc_id";
      $res=SQL_QUERY($query, $dbproc);
      if (!isset($res)) $status+=2;

      /* suppression de la doc*/
      $query="DELETE FROM docs WHERE id=$doc_id";
      $res=SQL_QUERY($query, $dbproc);
      if (!isset($res)) $status+=8;

      /* si ok ?*/
      if ($status==0)
	{
	  SQL_COMMIT($dbproc);
	  return 0;
	}
      else /* sinon renvoi valeur d'erreur */
	{
	  SQL_ROLLBACK($dbproc);
	  return $status;
	}
    }
else
  return -1; /* erreur */

}

################################################### INSERTION DE DOCUMENTATION

function SQL_DOC_INSERT( $dbproc, $datas, $products)
{
if (isset($datas))
    {
     /* init transaction */
     SQL_BEGIN($dbproc);
     $status=0;

     $doc_id=SQL_NEXT_ID($dbproc,"docs_id_seq");

     /* On insert les textes depassant 255 caractres */

     if (strlen($datas['content'])>255)
        {
        $res=SQL_DOCTEXT_INSERT($dbproc,$datas['content'], $doc_id, $datas['login_id']);
        if ($res==-1) $status+=1;
        }

     /* on remplit la table de liaison avec les produits*/

     if (is_array($products))
     {
        $prdc=count($products);
        for ($index=0;$index<$prdc;$index++)
            {
                $query="INSERT INTO doc_prod (  prod_id,
                                                        doc_id,
                                                        login_id
                                                      )
                               VALUES
                                                  (
                                                    '".$products[$index]."',
                                                    '".$doc_id."',
                                                    '".$datas['login_id']."'
                                                  )";
               $res=SQL_QUERY($query, $dbproc);

            }
     }

    $query="INSERT INTO  docs  (
                                   id,
                                   login_id,
                                   type,
                                   short_desc,
                                   content
                                  )
                     VALUES
                                  ('".$doc_id."',
                                   '".$datas['login_id']."',
                                   '".$datas['type']."',
                                   '".$datas['short_desc']."',
                                   '".addslashes(substr($datas['content'],0,255))."')";


     $SQL_RESULT=SQL_QUERY($query, $dbproc);

     /*fin de transaction */

     if ($SQL_RESULT && ($status==0))

        {
        SQL_FREE_RESULT($SQL_RESULT);
        SQL_COMMIT($dbproc);
        return $doc_id;
            }
    else
        {
        SQL_FREE_RESULT($SQL_RESULT);
        SQL_ROLLBACK($dbproc);
        return $status;
            }

    }
    else
    return $status;

}

################################################       INSERTION DES TEXTES D UNE DOCUMENTATION

/*     info: La transaction est dj initi dans la fonction appellante */

function SQL_DOCTEXT_INSERT($dbproc,$str, $doc_id, $login_id)
{
if (strlen($str)>255 && (isset($doc_id)))
{
    // on verifie si il y a deja des enregistrement concernant cette action
    $query="SELECT count(id),insdate from  doctext 
            WHERE id=$doc_id
            GROUP BY insdate";

    $sql_result=SQL_QUERY($query, $dbproc);

    if ($sql_result)
        {
        $dat=SQL_FETCH_RESULT($sql_result);
        $or_ins_date=$dat[0]['insdate'];
        }
    else
        {
        $num=0;
        $or_ins_date='';
        }

    // on les efface aprs avoir garder leur ins_date
    if ($num>0)
      {
      $query="delete from  doctext  where id=$doc_id";
      SQL_QUERY($query, $dbproc);
      }
    // on dcoupe le str en bloc de 255 caractres
    // mais on commence  1 car les premiers 255 sont inscrit dans la table principale

    $seq = 1;
    $size = 255;
    $text_success = 1;
    while ($docxt_str = addslashes(substr($str,$seq*$size,$size)))
    {
    $doc_txt_id=SQL_NEXT_ID($dbproc, "doctext_id_seq");

        if ($or_ins_date<>"")
            {
            $query = "INSERT INTO  doctext 
                    (id, doc_id, seq, str, login_id, insdate)
                    VALUES ('$doc_txt_id','$doc_id','$seq','$docxt_str',
                    '$login_id','$or_ins_date')";
            }
        else
            {
            $query = "INSERT INTO  doctext 
              (id, doc_id, seq, str, login_id)
              VALUES ('$doc_txt_id','$doc_id','$seq','".$docxt_str."',
              '$login_id')";

            }

    $sql_result2=SQL_QUERY($query, $dbproc);

    if ($sql_result2 AND $text_success > 0)

        $text_success = 1;
    else
        $text_success = 0;

    $seq++;
    }
}
else
 return -1;
}
?>
