\connect - postgres

DROP SEQUENCE mparc_id_seq;
CREATE SEQUENCE mparc_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
DROP TABLE machineparc;
CREATE TABLE machineparc (
  mparc_id int4 DEFAULT nextval('machine_id_seq'::text) NOT NULL,
  mparc_name character varying(63),
  mparc_comment character varying(255),
  cmp_id int4 DEFAULT 0 NOT NULL,
  user_id int4 DEFAULT 0 NOT NULL,
  ins_date timestamp DEFAULT NOW() NOT NULL,
  upd_date timestamp DEFAULT NOW() NOT NULL,
  ts timestamp DEFAULT NOW() NOT NULL,
  PRIMARY KEY ("mparc_id")
);

DROP SEQUENCE machine_id_seq;
CREATE SEQUENCE machine_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
DROP TABLE machine;
CREATE TABLE machine (
  machine_id int4 DEFAULT nextval('machine_id_seq'::text) NOT NULL,
  machine_name character varying(63),
  machine_serialnum character varying(63),
  machine_comment character varying(255),
  mstat_id int4 DEFAULT 0 NOT NULL,
  mparc_id int4 DEFAULT 0 NOT NULL,
  refmachine_id int4 DEFAULT 0 NOT NULL,
  user_id int4 DEFAULT 0 NOT NULL,
  ins_date timestamp DEFAULT NOW() NOT NULL,
  upd_date timestamp DEFAULT NOW() NOT NULL,
  ts timestamp DEFAULT NOW() NOT NULL,
  PRIMARY KEY ("machine_id")
);

DROP SEQUENCE helem_id_seq;
CREATE SEQUENCE helem_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
DROP TABLE hardelem;
CREATE TABLE hardelem (
  helem_id int4 DEFAULT nextval('helem_id_seq'::text) NOT NULL,
  helem_serialnum character varying(63),
  helem_rev character varying(31),
  helem_comment character varying(255),
  machine_id int4 DEFAULT 0 NOT NULL,
  refhard_id int4 DEFAULT 0 NOT NULL,
  user_id int4 DEFAULT 0 NOT NULL,
  ins_date timestamp DEFAULT NOW() NOT NULL,
  upd_date timestamp DEFAULT NOW() NOT NULL,
  ts timestamp DEFAULT NOW() NOT NULL,
  PRIMARY KEY ("helem_id")
);

DROP SEQUENCE selem_id_seq;
CREATE SEQUENCE selem_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
DROP TABLE softelem;
CREATE TABLE softelem (
  selem_id int4 DEFAULT nextval('selem_id_seq'::text) NOT NULL,
  selem_serialnum character varying(63),
  selem_ver character varying(31),
  selem_comment character varying(255),
  machine_id int4 DEFAULT 0 NOT NULL,
  refsoft_id int4 DEFAULT 0 NOT NULL,
  user_id int4 DEFAULT 0 NOT NULL,
  ins_date timestamp DEFAULT NOW() NOT NULL,
  upd_date timestamp DEFAULT NOW() NOT NULL,
  ts timestamp DEFAULT NOW() NOT NULL,
  PRIMARY KEY ("selem_id")
);

DROP SEQUENCE netconf_id_seq;
CREATE SEQUENCE netconf_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
DROP TABLE networkconfig;
CREATE TABLE networkconfig (
  netconf_id int4 DEFAULT nextval('netconf_id_seq'::text) NOT NULL,
  netconf_adr character varying(63),
  netconf_socketnumber character varying(15),
  netconf_comment character varying(255),
  refnettype_id int4 DEFAULT 0 NOT NULL,
  machine_id int4 DEFAULT 0 NOT NULL,
  user_id int4 DEFAULT 0 NOT NULL,
  ins_date timestamp DEFAULT NOW() NOT NULL,
  upd_date timestamp DEFAULT NOW() NOT NULL,
  ts timestamp DEFAULT NOW() NOT NULL,
  PRIMARY KEY ("netconf_id")
);

DROP SEQUENCE serprd_id_seq;
CREATE SEQUENCE serprd_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
DROP TABLE serverproduct;
CREATE TABLE serverproduct (
  serprd_id int4 DEFAULT nextval('serprd_id_seq'::text) NOT NULL,
  machine_id int4 DEFAULT 0 NOT NULL,
  ctrprd_id int4 DEFAULT 0 NOT NULL,
  user_id int4 DEFAULT 0 NOT NULL,
  ins_date timestamp DEFAULT NOW() NOT NULL,
  upd_date timestamp DEFAULT NOW() NOT NULL,
  ts timestamp DEFAULT NOW() NOT NULL,
  PRIMARY KEY ("serprd_id")
);

DROP SEQUENCE mstat_id_seq;
CREATE SEQUENCE mstat_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
DROP TABLE machinestatus;
CREATE TABLE machinestatus (
  mstat_id int4 DEFAULT nextval('mstat_id_seq'::text) NOT NULL,
  mstat_lbl character varying(31),
  user_id int4 DEFAULT 0 NOT NULL,
  ins_date timestamp DEFAULT NOW() NOT NULL,
  upd_date timestamp DEFAULT NOW() NOT NULL,
  ts timestamp DEFAULT NOW() NOT NULL,
  PRIMARY KEY ("mstat_id")
);

DROP SEQUENCE mhist_id_seq;
CREATE SEQUENCE mhist_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
DROP TABLE machinehistory;
CREATE TABLE machinehistory (
  mhist_id int4 DEFAULT nextval('mhist_id_seq'::text) NOT NULL,
  mhist_comment character varying(255),
  mhist_startdate timestamp,
  mhist_enddate timestamp,
  machine_id int4 DEFAULT 0 NOT NULL,
  per_id int4 DEFAULT 0 NOT NULL,
  user_id int4 DEFAULT 0 NOT NULL,
  ins_date timestamp DEFAULT NOW() NOT NULL,
  upd_date timestamp DEFAULT NOW() NOT NULL,
  ts timestamp DEFAULT NOW() NOT NULL,
  PRIMARY KEY ("mhist_id")
);

DROP SEQUENCE refmachine_id_seq;
CREATE SEQUENCE refmachine_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
DROP TABLE refmachine;
CREATE TABLE refmachine (
  refmachine_id int4 DEFAULT nextval('refmachine_id_seq'::text) NOT NULL,
  refmachine_lbl character varying(31),
  refmachine_icon character varying(63),
  user_id int4 DEFAULT 0 NOT NULL,
  ins_date timestamp DEFAULT NOW() NOT NULL,
  upd_date timestamp DEFAULT NOW() NOT NULL,
  ts timestamp DEFAULT NOW() NOT NULL,
  PRIMARY KEY ("refmachine_id")
);

DROP SEQUENCE refhard_id_seq;
CREATE SEQUENCE refhard_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
DROP TABLE refhardware;
CREATE TABLE refhardware (
  refhard_id int4 DEFAULT nextval('refhard_id_seq'::text) NOT NULL,
  refhard_name character varying(63),
  refhard_subname character varying(63),
  refhardtype_id int4 DEFAULT 0 NOT NULL,
  refmachine_id int4 DEFAULT 0 NOT NULL,
  const_id int4 DEFAULT 0 NOT NULL,
  user_id int4 DEFAULT 0 NOT NULL,
  ins_date timestamp DEFAULT NOW() NOT NULL,
  upd_date timestamp DEFAULT NOW() NOT NULL,
  ts timestamp DEFAULT NOW() NOT NULL,
  PRIMARY KEY ("refhard_id")
);

DROP SEQUENCE refsoft_id_seq;
CREATE SEQUENCE refsoft_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
DROP TABLE refsoftware;
CREATE TABLE refsoftware (
  refsoft_id int4 DEFAULT nextval('refsoft_id_seq'::text) NOT NULL,
  refsoft_name character varying(63),
  refsoft_subname character varying(63),
  refsofttype_id int4 DEFAULT 0 NOT NULL,
  prd_id int4 DEFAULT 0 NOT NULL,
  const_id int4 DEFAULT 0 NOT NULL,
  user_id int4 DEFAULT 0 NOT NULL,
  ins_date timestamp DEFAULT NOW() NOT NULL,
  upd_date timestamp DEFAULT NOW() NOT NULL,
  ts timestamp DEFAULT NOW() NOT NULL,
  PRIMARY KEY ("refsoft_id")
);

DROP SEQUENCE refhardtype_id_seq;
CREATE SEQUENCE refhardtype_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
DROP TABLE refhardtype;
CREATE TABLE refhardtype (
  refhardtype_id int4 DEFAULT nextval('refhardtype_id_seq'::text) NOT NULL,
  refhardtype_lbl character varying(63),
  refhardtype_icon character varying(63),
  user_id int4 DEFAULT 0 NOT NULL,
  ins_date timestamp DEFAULT NOW() NOT NULL,
  upd_date timestamp DEFAULT NOW() NOT NULL,
  ts timestamp DEFAULT NOW() NOT NULL,
  PRIMARY KEY ("refhardtype_id")
);

DROP SEQUENCE refsofttype_id_seq;
CREATE SEQUENCE refsofttype_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
DROP TABLE refsofttype;
CREATE TABLE refsofttype (
  refsofttype_id int4 DEFAULT nextval('refsofttype_id_seq'::text) NOT NULL,
  refsofttype_lbl character varying(63),
  refsofttype_icon character varying(63),
  user_id int4 DEFAULT 0 NOT NULL,
  ins_date timestamp DEFAULT NOW() NOT NULL,
  upd_date timestamp DEFAULT NOW() NOT NULL,
  ts timestamp DEFAULT NOW() NOT NULL,
  PRIMARY KEY ("refsofttype_id")
);

DROP SEQUENCE hardmach_id_seq;
CREATE SEQUENCE hardmach_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
DROP TABLE hardwaremachine;
CREATE TABLE hardwaremachine (
  hardmach_id int4 DEFAULT nextval('hardmach_id_seq'::text) NOT NULL,
  refmachine_id int4 DEFAULT 0 NOT NULL,
  refhard_id int4 DEFAULT 0 NOT NULL,
  user_id int4 DEFAULT 0 NOT NULL,
  ins_date timestamp DEFAULT NOW() NOT NULL,
  upd_date timestamp DEFAULT NOW() NOT NULL,
  ts timestamp DEFAULT NOW() NOT NULL,
  PRIMARY KEY ("hardmach_id")
);

DROP SEQUENCE eprice_id_seq;
CREATE SEQUENCE eprice_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
DROP TABLE elemprice;
CREATE TABLE elemprice (
  eprice_id int4 DEFAULT nextval('eprice_id_seq'::text) NOT NULL,
  eprice_price numeric(10,2) DEFAULT 0 NOT NULL,
  eprice_taxrate numeric(3,2) DEFAULT 0 NOT NULL,
  eprice_currency character varying(2),
  eprice_buydate timestamp,
  mfact_id int4 DEFAULT 0 NOT NULL,
  helem_id int4 DEFAULT 0 NOT NULL,
  selem_id int4 DEFAULT 0 NOT NULL,
  user_id int4 DEFAULT 0 NOT NULL,
  ins_date timestamp DEFAULT NOW() NOT NULL,
  upd_date timestamp DEFAULT NOW() NOT NULL,
  ts timestamp DEFAULT NOW() NOT NULL,
  PRIMARY KEY ("eprice_id")
);

DROP SEQUENCE mfact_id_seq;
CREATE SEQUENCE mfact_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
DROP TABLE machinefact;
CREATE TABLE machinefact (
  mfact_id int4 DEFAULT nextval('mfact_id_seq'::text) NOT NULL,
  mfact_comment character varying(255),
  mfact_date timestamp DEFAULT NOW() NOT NULL,
  cmp_id int4 DEFAULT 0 NOT NULL,
  user_id int4 DEFAULT 0 NOT NULL,
  ins_date timestamp DEFAULT NOW() NOT NULL,
  upd_date timestamp DEFAULT NOW() NOT NULL,
  ts timestamp DEFAULT NOW() NOT NULL,
  PRIMARY KEY ("mfact_id")
);

DROP SEQUENCE const_id_seq;
CREATE SEQUENCE const_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;
DROP TABLE constructor;
CREATE TABLE constructor (
  const_id int4 DEFAULT nextval('const_id_seq'::text) NOT NULL,
  const_name character varying(63),
  cmp_id int4 DEFAULT 0 NOT NULL,
  user_id int4 DEFAULT 0 NOT NULL,
  ins_date timestamp DEFAULT NOW() NOT NULL,
  upd_date timestamp DEFAULT NOW() NOT NULL,
  ts timestamp DEFAULT NOW() NOT NULL,
  PRIMARY KEY ("const_id")
);






