<?
##########################################################
#
#    FONCTIONS SQL POUR LE MODULE DE GESTION DE PARC
#
#    Antoine Bajolet 2001-13-02 OIC
#
######################################################

//Read all parcs from a company or one where $mparc_id is supplied
function SQL_READ_PARCS($dbproc,$cmp_id,$mparc_id=0,$mode="full")
    {
    if ($mparc_id)
        $where = "mparc_id=$mparc_id";
    elseif ($cmp_id)
        $where = "cmp_id=$cmp_id";
    else
        $where = "FALSE";
    if ($mode == "ref")
    	$query = "SELECT mparc_id as id,mparc_name as label FROM machineparc WHERE $where ORDER BY label";
    else
    	$query = "SELECT mparc_id,mparc_name,mparc_comment,cmp_id FROM machineparc WHERE $where ORDER BY mparc_name";
    return SQL_FETCH_RESULT(SQL_QUERY($query,$dbproc));
    }


//Read all machines from a parc or one where $machine_id is supplied
function SQL_READ_MACHINES($dbproc,$mparc_id="",$machine_id="",$mode="full")
    {
    if ($machine_id)
        $where = "mac.machine_id=$machine_id";
    elseif($mparc_id or $mparc_id == 0)
        $where = "mac.mparc_id=$mparc_id";
    else
        $where = "FALSE";

    if ($mode == "ref")
    	$query = "SELECT mac.machine_id as id, mac.machine_name as label FROM machine mac WHERE $where ORDER BY label";
    else
    {
    if ($mparc_id > 0)
        {
        $field_more = ",mparc.mparc_name";
        $table_more =  ",machineparc mparc";
        $where_more =  "AND mac.mparc_id = mparc.mparc_id";
        }

    $query = "SELECT
                mac.machine_id,
                mac.machine_name,
                mac.machine_serialnum,
                mac.machine_comment,
                mac.mparc_id,
                msts.mstat_lbl,
                msts.mstat_id,
                rmac.refmachine_id,
                rmac.refmachine_lbl,
                rmac.refmachine_icon
                $field_more
              FROM
                machine mac,
                refmachine rmac,
                machinestatus msts
                $table_more
              WHERE $where
                AND mac.mstat_id = msts.mstat_id
                AND mac.refmachine_id = rmac.refmachine_id
                $where_more
              ORDER BY refmachine_lbl DESC,mstat_lbl,machine_name";
    }
    return SQL_FETCH_RESULT(SQL_QUERY($query,$dbproc));
    }

//change the parc for a machine
function SQL_AFFECT_MACHINE($dbproc,$user_id,$machine_id,$mparc_id=0)
{
$query = "UPDATE machine SET mparc_id='$mparc_id' WHERE machine_id='$machine_id'";
SQL_BEGIN($dbproc);
$res =SQL_QUERY($query,$dbproc);
if ($res)
    {
    SQL_COMMIT($dbproc);
    return 1;
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }
}

//read a reference table
function SQL_READ_PARCREF($dbproc,$refdatas,$id=0,$refname="")
{
if ($id > 0)
    $where = "WHERE ".$refdatas['id']."=$id";
elseif ($refname)
    $where = "WHERE UPPER(".$refdatas['label'].") LIKE '".strtoupper($refname)."'";

$query = "SELECT ".$refdatas['id']." as id,".$refdatas['label']." as label,".$refdatas['more']." as more FROM ".$refdatas['table']." $where ORDER BY label";
return SQL_FETCH_RESULT(SQL_QUERY($query,$dbproc));
}


//insert into a reference table
function SQL_INSERT_PARCREF($dbproc,$insertdatas,$refdatas,$user_id=0)
{
SQL_BEGIN($dbproc);
$id = SQL_NEXT_ID($dbproc,$refdatas['id']."_seq");
$query = "INSERT INTO ".$refdatas['table']." (".$refdatas['id'].",".$refdatas['label'].",".$refdatas['more'].",user_id,ins_date,upd_date,ts)
            VALUES ($id,'".$insertdatas['label']."','".$insertdatas['more']."',$user_id,NOW(),NOW(),NOW())";
$res = SQL_QUERY($query,$dbproc);
if ($res)
    {
    SQL_COMMIT($dbproc);
    return $id;
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }
}

//update a reference table
function SQL_UPDATE_PARCREF($dbproc,$insertdatas,$refdatas,$user_id=0)
{
SQL_BEGIN($dbproc);
$query = "UPDATE ".$refdatas['table']."
          SET ".$refdatas['label']."='".$insertdatas['label']."',
              ".$refdatas['more']."='".$insertdatas['more']."',
              user_id=$user_id,
              upd_date=NOW()
          WHERE
             ".$refdatas['id']."=".$insertdatas['id'];

$res = SQL_QUERY($query,$dbproc);
if ($res)
    {
    SQL_COMMIT($dbproc);
    return $id;
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }
}

//insert a machine parc
function SQL_INSERT_PARC($dbproc,$datas)
{
$datas = ADD_SLASHES($datas);
SQL_BEGIN($dbproc);
$id = SQL_NEXT_ID($dbproc,"machine_id_seq");
$query = "INSERT INTO machineparc (mparc_id,mparc_name,mparc_comment,cmp_id,user_id,ins_date,upd_date,ts)
            VALUES ($id,'".$datas['mparc_name']."','".$datas['mparc_comment']."','".$datas['cmp_id']."',".$datas['user_id'].",NOW(),NOW(),NOW())";
$res = SQL_QUERY($query,$dbproc);
if ($res)
    {
    SQL_COMMIT($dbproc);
    return $id;
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }
}

//update a machine parc
function SQL_UPDATE_PARC($dbproc,$datas,$mparc_id)
{
$datas = ADD_SLASHES($datas);
SQL_BEGIN($dbproc);
$query = "UPDATE machineparc
            SET
            mparc_name='".$datas['mparc_name']."',
            mparc_comment='".$datas['mparc_comment']."',
            user_id=".$datas['user_id'].",
            upd_date=NOW()
            WHERE mparc_id=$mparc_id
            ";
$res = SQL_QUERY($query,$dbproc);
if ($res)
    {
    SQL_COMMIT($dbproc);
    return $mparc_id;
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }
}

//update a machine parc
function SQL_DELETE_PARC($dbproc,$mparc_id)
{
$status = 0;
SQL_BEGIN($dbproc);
$query = "UPDATE machine
            SET
            mparc_id = 0
            WHERE mparc_id=$mparc_id
            ";
if (!SQL_QUERY($query,$dbproc))
    $status ++;

$query = "DELETE FROM machineparc
            WHERE mparc_id=$mparc_id
            ";
if (!SQL_QUERY($query,$dbproc))
    $status ++;

if ($status == 0)
    {
    SQL_COMMIT($dbproc);
    return 1;
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }
}

//read a list of hardware references, sorted by constructor or type or name...
function SQL_READ_REFHARD($dbproc,$const_id,$refhardtype_id,$refhard_id=0)
    {
    if ($refhard_id > 0)
        {
        $category = "rhtype.refhardtype_id as refcat_id, const.const_id, const.const_name,";
        $where = "AND rhard.refhard_id = $refhard_id";
        }
    elseif ($const_id && !$refhardtype_id)
        {
        $category = "rhtype.refhardtype_id as refcat_id, const.const_id, rhtype.refhardtype_lbl as category,rhtype.refhardtype_icon as icon, const.const_name,";
        $orderby = "ORDER BY category,name,subname";
        $where = "AND const.const_id = $const_id";
        }
    elseif (!$const_id && $refhardtype_id)
        {
        $category = "rhtype.refhardtype_id as refcat_id, const.const_id, const.const_name as category, const.const_name,";
        $orderby = "ORDER BY category,name,subname";
        $where = "AND rhtype.refhardtype_id = $refhardtype_id";
        }
    elseif ($const_id && $refhardtype_id)
        {
        $category = "rhtype.refhardtype_id as refcat_id, const.const_id, const.const_name,";
        $orderby = "ORDER BY name,subname";
        $where = "AND rhtype.refhardtype_id = $refhardtype_id AND const.const_id = $const_id";
        }
    else
        {
        return 0;
        }
    $query = "SELECT $category rhard.refhard_id as id, rhard.refhard_name as name, rhard.refhard_subname as subname
               FROM refhardware rhard, refhardtype rhtype, constructor const
               WHERE rhard.const_id = const.const_id AND rhard.refhardtype_id = rhtype.refhardtype_id
               $where
               $orderby";

   return STRIP_SLASHES(SQL_FETCH_RESULT(SQL_QUERY($query,$dbproc)));
   }

//read a list of software references, sorted by constructor or type or name...
function SQL_READ_REFSOFT($dbproc,$const_id,$refsofttype_id,$refsoft_id=0)
    {
    if ($refsoft_id > 0)
        {
        $category = "rstype.refsofttype_id as refcat_id, const.const_id,";
        $where = "AND rsoft.refsoft_id = $refsoft_id";
        }
    elseif ($const_id && !$refsofttype_id)
        {
        $category = "rstype.refsofttype_id as refcat_id, const.const_id, rstype.refsofttype_lbl as category,rstype.refsofttype_icon as icon,";
        $orderby = "ORDER BY category,name,subname";
        $where = "AND const.const_id = $const_id";
        }
    elseif (!$const_id && $refsofttype_id)
        {
        $category = "rstype.refsofttype_id as refcat_id, const.const_id, const.const_name as category,";
        $orderby = "ORDER BY category,name,subname";
        $where = "AND rstype.refsofttype_id = $refsofttype_id";
        }
    elseif ($const_id && $refsofttype_id)
        {
        $category = "rstype.refsofttype_id as refcat_id, const.const_id,";
        $orderby = "ORDER BY name,subname";
        $where = "AND rstype.refsofttype_id = $refsofttype_id AND const.const_id = $const_id";
        }
    else
        {
        return 0;
        }
    $query = "SELECT $category rsoft.refsoft_id as id, rsoft.refsoft_name as name, rsoft.refsoft_subname as subname, rsoft.prd_id as more
               FROM refsoftware rsoft, refsofttype rstype, constructor const
               WHERE rsoft.const_id = const.const_id AND rsoft.refsofttype_id = rstype.refsofttype_id
               $where
               $orderby";
	//echo $query;
   return STRIP_SLASHES(SQL_FETCH_RESULT(SQL_QUERY($query,$dbproc)));
   }

//update a hardware reference
function SQL_UPDATE_REFHARD($dbproc,$datas)
{
$datas = ADD_SLASHES($datas);
SQL_BEGIN($dbproc);
$query = "UPDATE refhardware
            SET
            refhard_name='".$datas['refhard_name']."',
            refhard_subname='".$datas['refhard_subname']."',
            user_id=".$datas['user_id'].",
            upd_date=NOW()
            WHERE refhard_id=".$datas['refhard_id']."
            ";
$res = SQL_QUERY($query,$dbproc);
if ($res)
    {
    SQL_COMMIT($dbproc);
    return $datas['refhard_id'];
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }
}

//insert a hardware reference
function SQL_INSERT_REFHARD($dbproc,$datas)
{
$datas = ADD_SLASHES($datas);
SQL_BEGIN($dbproc);
$id = SQL_NEXT_ID($dbproc,"refhard_id_seq");
$query = "INSERT INTO refhardware (refhard_id,refhard_name,refhard_subname,refhardtype_id,const_id,user_id,ins_date,upd_date,ts)
            VALUES ($id,'".$datas['refhard_name']."','".$datas['refhard_subname']."','".$datas['refhardtype_id']."','".$datas['const_id']."',".$datas['user_id'].",NOW(),NOW(),NOW())";
$res = SQL_QUERY($query,$dbproc);
if ($res)
    {
    SQL_COMMIT($dbproc);
    return $id;
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }
}

//update a software reference
function SQL_UPDATE_REFSOFT($dbproc,$datas)
{
$datas = ADD_SLASHES($datas);
SQL_BEGIN($dbproc);
$query = "UPDATE refsoftware
            SET
            refsoft_name='".$datas['refsoft_name']."',
            refsoft_subname='".$datas['refsoft_subname']."',
            prd_id='".$datas['prd_id']."',
            user_id=".$datas['user_id'].",
            upd_date=NOW()
            WHERE refsoft_id=".$datas['refsoft_id']."
            ";
$res = SQL_QUERY($query,$dbproc);
if ($res)
    {
    SQL_COMMIT($dbproc);
    return $datas['refsoft_id'];
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }
}

//insert a software reference
function SQL_INSERT_REFSOFT($dbproc,$datas)
{
$datas = ADD_SLASHES($datas);
SQL_BEGIN($dbproc);
$id = SQL_NEXT_ID($dbproc,"refsoft_id_seq");
$query = "INSERT INTO refsoftware (refsoft_id,refsoft_name,refsoft_subname,refsofttype_id,const_id,prd_id,user_id,ins_date,upd_date,ts)
            VALUES ($id,'".$datas['refsoft_name']."','".$datas['refsoft_subname']."','".$datas['refsofttype_id']."','".$datas['const_id']."','".$datas['prd_id']."',".$datas['user_id'].",NOW(),NOW(),NOW())";
$res = SQL_QUERY($query,$dbproc);
if ($res)
    {
    SQL_COMMIT($dbproc);
    return $id;
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }
}

//insert a machine
function SQL_INSERT_MACHINE($dbproc,$datas)
{
$datas = ADD_SLASHES($datas);
SQL_BEGIN($dbproc);
$id = SQL_NEXT_ID($dbproc,"machine_id_seq");
$query = "INSERT INTO machine (machine_id,mstat_id,machine_name,machine_serialnum,machine_comment,refmachine_id,mparc_id,user_id,ins_date,upd_date,ts)
            VALUES ($id,1,'".$datas['machine_name']."','".$datas['machine_serialnum']."','".$datas['machine_comment']."','".$datas['refmachine_id']."','".$datas['mparc_id']."',".$datas['user_id'].",NOW(),NOW(),NOW())";
$res = SQL_QUERY($query,$dbproc);
if ($res)
    {
    SQL_COMMIT($dbproc);
    return $id;
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }
}

//update a machine
function SQL_UPDATE_MACHINE($dbproc,$datas,$machine_id)
{
settype($machine_id,'integer');
$datas = ADD_SLASHES($datas);
SQL_BEGIN($dbproc);
$query = "UPDATE machine SET
                machine_name = '".$datas['machine_name']."',
                machine_serialnum ='".$datas['machine_serialnum']."',
                machine_comment ='".$datas['machine_comment']."',
                refmachine_id = '".$datas['refmachine_id']."',
                user_id = ".$datas['user_id'].",
                upd_date = NOW()
           WHERE
                machine_id = $machine_id";
$res = SQL_QUERY($query,$dbproc);
if ($res)
    {
    SQL_COMMIT($dbproc);
    return $id;
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }
}

//retrieve persons wo can own a machine in a parc
function SQL_READ_PERFORPARC($dbproc,$mparc_id,$machine_id)
{
settype ($mparc_id,"integer");
settype ($machine_id,"integer");
if ($machine_id > 0 and $mparc_id == 0)
	{
	$where = "AND mac.mparc_id = mparc.mparc_id AND mac.machine_id=$machine_id";
	$tables = ",machine mac";
	}
elseif ($mparc_id > 0)
	{
	$where = "AND mparc_id = $mparc_id";
	}
else
	{
	$where = "AND FALSE";
	}
$query = "SELECT
		per.per_id, per.per_firstname, per.per_lastname_flat, cmp.cmp_id
	  FROM
	  	person per, entity ent, company cmp, machineparc mparc $tables
	  WHERE
	  	per.ent_id = ent.ent_id
	  	AND cmp.ent_id = ent.ent_hier_id
	  	AND cmp.cmp_id = mparc.cmp_id
	  	$where
	  ORDER BY
	  	per.per_lastname_flat, per.per_firstname
	  	";
$res = SQL_QUERY($query,$dbproc);
if ($res)
	return STRIP_SLASHES(SQL_FETCH_RESULT($res));
else
	return -1;	
	  	
}

//update the status of a machine
function SQL_UPDATE_MACHINE_STATUS($dbproc,$machine_id=0,$mstat_id=0,$user_id=0)
{
$query = "UPDATE machine SET mstat_id = $mstat_id,user_id=$user_id,upd_date=NOW() WHERE machine_id = $machine_id";
$res = SQL_QUERY($query,$dbproc);
if ($res)
    {
    SQL_COMMIT($dbproc);
    return 1;
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }
}

//read history of owners of a machine
function SQL_READ_MACHINE_HISTORY($dbproc,$machine_id=0,$mode="all")
{
if ($mode == "last")
	$where = "AND mhist.mhist_enddate IS NULL";
$query = "SELECT per.per_id,per.per_firstname,per.per_lastname_flat,mhist.mhist_id,mhist.mhist_comment,mhist.mhist_startdate,mhist.mhist_enddate
		FROM machinehistory mhist, person per
		WHERE mhist.machine_id = $machine_id AND mhist.per_id = per.per_id $where
		ORDER BY mhist_startdate DESC";

$res = SQL_QUERY($query,$dbproc);
if ($res)
	return STRIP_SLASHES(SQL_FETCH_RESULT($res));
else
	return -1;		
		
}

//New ligne of history for a machine
function SQL_UPDATE_MACHINE_HISTORY($dbproc,$machine_id,$per_id,$comments='',$user_id=0)
{
if ($comments)
	$comments = ADD_SLASHES($comments);
settype($machine_id,'integer');
settype($per_id,'integer');

SQL_BEGIN($dbproc);
$query1 = "UPDATE machinehistory SET mhist_enddate = NOW(),upd_date = NOW() WHERE mhist_enddate IS NULL AND machine_id=$machine_id";
if (!SQL_QUERY($query1,$dbproc))
	$status++;
$id = SQL_NEXT_ID($dbproc,"mhist_id_seq");
$query2 = "INSERT INTO machinehistory (mhist_id, machine_id, per_id, mhist_comment, mhist_startdate, user_id, ins_date, upd_date, ts) VALUES ($id,$machine_id,$per_id,'$comments',NOW(),$user_id,NOW(),NOW(),NOW() )";

if (!SQL_QUERY($query2,$dbproc))
	$status++;

if ($status == 0)
    {
    SQL_COMMIT($dbproc);
    return $id;
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }
}

//Create an instance of hardware element
function SQL_INSERT_HARDELEM($dbproc,$datas)
{
$datas = ADD_SLASHES($datas);
SQL_BEGIN($dbproc);
$id = SQL_NEXT_ID($dbproc,'helem_id_seq');
$query = "INSERT INTO hardelem
			(
			helem_id,
			helem_serialnum,
			helem_rev,
			helem_comment,
			machine_id,
			refhard_id,
			user_id,
			ins_date,upd_date,ts
			)
			VALUES
			(
			$id,
			'".$datas['elem_serialnum']."',
			'".$datas['elem_ver']."',
			'".$datas['elem_comment']."',
			'".$datas['machine_id']."',
			'".$datas['ref_id']."',
			'".$datas['user_id']."',
			NOW(),NOW(),NOW()
			)
			";
$res = SQL_QUERY($query,$dbproc);
if ($res)
    {
    SQL_COMMIT($dbproc);
    return $id;
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }			
}

//Update an instance of hardware element
function SQL_UPDATE_HARDELEM($dbproc,$datas)
{
$datas = ADD_SLASHES($datas);
SQL_BEGIN($dbproc);
$query = "UPDATE hardelem
			SET
			helem_serialnum = '".$datas['elem_serialnum']."',
			helem_rev = '".$datas['elem_ver']."',
			helem_comment = '".$datas['elem_comment']."',
			refhard_id = '".$datas['ref_id']."',
			user_id = '".$datas['user_id']."',
			upd_date = NOW()
			WHERE helem_id = ".$datas['elem_id']."
			";
$res = SQL_QUERY($query,$dbproc);
if ($res)
    {
    SQL_COMMIT($dbproc);
    return 1;
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }
}

//Create an instance of software element
function SQL_INSERT_SOFTELEM($dbproc,$datas)
{
$datas = ADD_SLASHES($datas);
SQL_BEGIN($dbproc);
$id = SQL_NEXT_ID($dbproc,'selem_id_seq');
$query = "INSERT INTO softelem
			(
			selem_id,
			selem_serialnum,
			selem_ver,
			selem_comment,
			machine_id,
			refsoft_id,
			user_id,
			ins_date,upd_date,ts
			)
			VALUES
			(
			$id,
			'".$datas['elem_serialnum']."',
			'".$datas['elem_ver']."',
			'".$datas['elem_comment']."',
			'".$datas['machine_id']."',
			'".$datas['ref_id']."',
			'".$datas['user_id']."',
			NOW(),NOW(),NOW()
			)
			";
$res = SQL_QUERY($query,$dbproc);
if ($res)
    {
    SQL_COMMIT($dbproc);
    return $id;
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }	
}

//Update an instance of software element
function SQL_UPDATE_SOFTELEM($dbproc,$datas)
{
$datas = ADD_SLASHES($datas);
SQL_BEGIN($dbproc);
$query = "UPDATE softelem
			SET
			selem_serialnum = '".$datas['elem_serialnum']."',
			selem_ver = '".$datas['elem_ver']."',
			selem_comment = '".$datas['elem_comment']."',
			refsoft_id = '".$datas['ref_id']."',
			user_id = '".$datas['user_id']."',
			upd_date = NOW()
			WHERE selem_id = ".$datas['elem_id']."
			";
$res = SQL_QUERY($query,$dbproc);
if ($res)
    {
    SQL_COMMIT($dbproc);
    return 1;
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }
}

//Read the content of a machine
function SQL_READ_MACHINE_CONTENT($dbproc,$machine_id=0,$mode="hardware",$id=0)
{
if ($mode == "software")
	{
	$initial = "s";
	$prefix = "soft";
	$ver = "ver";
	}
else
	{
	$mode = "hardware";
	$initial = "h";
	$prefix = "hard";
	$ver = "rev";
	}
if ($id > 0)
	$where = "AND $prefix.".$initial."elem_id = $id";
if ($machine_id > 0)
	$where2 = "AND $prefix.machine_id = $machine_id";
	
$query = "SELECT $prefix.".$initial."elem_id as id,
				$prefix.".$initial."elem_serialnum as serialnum,
				$prefix.".$initial."elem_comment as comment,
				$prefix.machine_id as machine_id,
				ref.ref".$prefix."_id as ref_id,
				ref.ref".$prefix."_name as name,
				ref.ref".$prefix."_subname as subname,
				rtype.ref".$prefix."type_id as cat_id,
				rtype.ref".$prefix."type_lbl as category,
				rtype.ref".$prefix."type_icon as icon,
				const.const_name as const_name,
				mac.machine_name as machine_name
			FROM
				".$prefix."elem as $prefix,
				ref".$mode." as ref,
				ref".$prefix."type as rtype,
				constructor as const,
				machine as mac
			WHERE
				$prefix.machine_id = mac.machine_id
				AND $prefix.ref".$prefix."_id = ref.ref".$prefix."_id
				AND ref.ref".$prefix."type_id = rtype.ref".$prefix."type_id
				AND ref.const_id = const.const_id
				$where
				$where2
			ORDER BY category, const_name, name		
				";
$res = SQL_QUERY($query,$dbproc);
if ($res)
	return STRIP_SLASHES(SQL_FETCH_RESULT($res));
else
	return -1;
}

//Retrieve a company starting with an element
function SQL_RETRIEVE_CMP($dbproc,$type="hardware",$elem_id=0)
{
switch ($type)
	{
	case "software":
	$where = "AND soft.machine_id = mac.machine_id AND soft.selem_id = $elem_id";
	$tables = "softelem soft";
	break;
	
	default:
	$where = "AND hard.machine_id = mac.machine_id AND hard.helem_id = $elem_id";
	$tables = "hardelem hard";
	}
$query = "SELECT mparc.cmp_id
			FROM machineparc mparc,	machine mac, $tables
			WHERE mac.mparc_id = mparc.mparc_id
			$where";
$res = SQL_QUERY($query,$dbproc);
if ($res)
	{
	$datas = SQL_FETCH_RESULT($res);
	if (is_array($datas))
		return $datas[0]['cmp_id'];
	else
		return 0;	
	}
else
	return -1;	
}

//move an element, soft or hard
function SQL_MOVE_ELEM($dbproc,$elem_id=0,$machine_id=0,$morigin=0,$mode="hardware",$user_id=0)
{
switch($mode)
	{
	case "software":
	$query = "UPDATE softelem SET machine_id=$machine_id,user_id=$user_id,upd_date=NOW() WHERE selem_id=$elem_id AND machine_id=$morigin";
	break;
	
	default:
	$query = "UPDATE hardelem SET machine_id=$machine_id,user_id=$user_id,upd_date=NOW() WHERE helem_id=$elem_id AND machine_id=$morigin";	
	}
SQL_BEGIN($dbproc);
$res = SQL_QUERY($query,$dbproc);
if ($res)
    {
    SQL_COMMIT($dbproc);
    return 1;
    }
else
    {
    SQL_ROLLBACK($dbproc);
    return -1;
    }
}
?>